﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Telerik.Windows.Controls.Charting;

namespace CameraExtensionsChartWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private bool Chart3d = false;
        private System.Data.DataTable dt = new DataTable();
        public MainWindow()
        {
            InitializeComponent();

            dt.Columns.Add("Month", typeof(string));
            dt.Columns.Add("Sales", typeof(double));
            dt.Rows.Add("Jan", 12000);
            dt.Rows.Add("Feb", 15500);
            dt.Rows.Add("Mar", 20000);
            dt.Rows.Add("Apr", 1300);
            dt.Rows.Add("May", 1200);
            dt.Rows.Add("Jun", 12000);
            dt.Rows.Add("Jul", 13000);
            dt.Rows.Add("Aug", 16000);
            dt.Rows.Add("Sep", 18000);
            dt.Rows.Add("Oct", 11000);
            dt.Rows.Add("Nov", 10000);
            dt.Rows.Add("Dec", 15000);
            //telerikChart.Loaded += new RoutedEventHandler(telerikChart_Loaded);
            InitChart();
            PlotChart(dt);
        }

        void telerikChart_Loaded(object sender, RoutedEventArgs e)
        {
            InitChart();
            PlotChart(dt);
        }

        private void checkBox1_Unchecked(object sender, RoutedEventArgs e)
        {
            Chart3d = false;
            if (dt.Rows.Count > 0)
            {
                InitChart();
                PlotChart(dt);
            }

        }

        private void checkBox1_Checked(object sender, RoutedEventArgs e)
        {
            Chart3d = true;
            if (dt.Rows.Count > 0)
            {
                InitChart();
                PlotChart(dt);
            }
        }

        private void InitChart()
        {
            telerikChart.DefaultView.ChartTitle.Content = "Year 2009";
            telerikChart.DefaultView.ChartTitle.HorizontalAlignment = HorizontalAlignment.Center;
            telerikChart.DefaultView.ChartLegend.UseAutoGeneratedItems = true;

            //telerikChart.ItemsSource = new DataTable();
            telerikChart.SeriesMappings.Clear();
            SeriesMapping sm = new SeriesMapping();

            if (Chart3d)
                sm.SeriesDefinition = new Line3DSeriesDefinition();
            else
                sm.SeriesDefinition = new LineSeriesDefinition();

            sm.ItemMappings.Add(new ItemMapping("Month", DataPointMember.XCategory));
            sm.ItemMappings.Add(new ItemMapping("Sales", DataPointMember.YValue));

            telerikChart.SeriesMappings.Add(sm);
            telerikChart.LayoutUpdated += this.telerikChart_LayoutUpdated;
        }

        void telerikChart_LayoutUpdated(object sender, EventArgs e)
        {
            telerikChart.LayoutUpdated -= this.telerikChart_LayoutUpdated;

            if (Chart3d)
            {
                telerikChart.DefaultView.ChartArea.Extensions.Clear();
                CameraExtension cameraExtension = new CameraExtension() { ZoomEnabled = true };
                telerikChart.DefaultView.ChartArea.Extensions.Add(cameraExtension);
                cameraExtension.Zoom(1.1);
            }
        }
           
        private void PlotChart(System.Data.DataTable dt)
        {
            telerikChart.ItemsSource = dt;
        }

    }
}